//+------------------------------------------------------------------+
//|                                          EMA Breakout expert.mq4 |
//|                                                        Klemen 4n |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Klemen 4n"
#property link      ""
int Verzija = 4;

// EURUSD ONLY!!! //

//---- input parameters
/* Moving average info */
extern int EmaPeriod = 44;
extern int EmaPrice = 3;
extern int MaMethod = 3;

/* RSI info */
extern int RsiPeriod = 28;

/* Long term trend EMA */
extern int EmaLong = 165;

/* Lots and lots optimization */
extern double Lots=0.1;
extern int OptimizeLots = 1;
extern int IncreaseLotsPer = 1000;
extern double MaxLots = 50;

/* Other settings */
extern double DifLimit = 0.002;
extern double TakeProfit=1000;
extern double StopLoss=50;
extern int Slippage=3;
extern int MagicNumber = 25122006;

static int newday;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {  
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {

   //LotCalc(1);
   int cnt, ticket, total, allSell=0, allBuy=0, thisEaOrders=0;
   if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
     }     
  
   if (OptimizeLots == 1) {
      static double UseLots;
   
      Lots = MathFloor(AccountBalance()/IncreaseLotsPer) * 0.1;
                      
      if (Lots < 0.2) {Lots = 0.1;}
      else if (Lots > MaxLots) {Lots = MaxLots;}
            
      if (Lots > UseLots) {
         UseLots = Lots;
      } else {
         Lots = UseLots;
      }
           
   }
   
   double MyEma, MyAsk, MyBid, MyRSI, MyBigEma;
   int isCrossed=0, tradeSignal=0;

   MyEma = iMA(NULL,0,EmaPeriod,0,MaMethod,EmaPrice,0);
   MyRSI = iRSI(NULL,0,RsiPeriod,0,0);
   MyBigEma = iMA(NULL,0,EmaLong,0,1,0,0);
   MyAsk = Ask;
   
   if (MathAbs(MyAsk-MyEma) > DifLimit) {
      isCrossed = Crossed(MyAsk,MyEma);  
   }
   
   if (isCrossed == 1 && MyRSI > 50) {
      tradeSignal = isCrossed;
   }
   if (isCrossed == 2 && MyRSI < 50) {
      tradeSignal = isCrossed;
   }   

   total  = OrdersTotal();
   for (cnt = 0 ; cnt < total ; cnt++)
   {
      OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == MagicNumber) {
         thisEaOrders = 1;
         if (OrderType()==OP_BUY) {
            allBuy = 1;
         }
         if(OrderType()==OP_SELL) {   
            allSell = 1;
         }
      }
   } 
   
   
   if (tradeSignal == 1 && allBuy < 1) {
      
      CloseAll();
         
      if (MyBigEma < MyAsk) {return(0);}
         
      if(Day()==newday) {
         return(0);
      } else {
         newday=Day();
      }         
         
      ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"EMA Expert v"+Verzija,MagicNumber,0,Green);
         if(ticket>0)
         {
               if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
         } else
         {
            Print("Error opening BUY order : ",GetLastError()); 
         }
         
      return(0);
   }

   if (tradeSignal == 2 && allSell < 1)
   {
      CloseAll();
      
      if (MyBigEma > MyAsk) {return(0);}
         
      if(Day()==newday) {
         return(0);
      } else {
         newday=Day();
      }  
             
      ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"EMA Expert v"+Verzija,MagicNumber,0,Red);
         if(ticket>0)
         {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
         }
         else 
         {
            Print("Error opening SELL order : ",GetLastError()); 
         }
            
      return(0);
   }

//----  
  
//----
   return(0);
  }
//+------------------------------------------------------------------+


void CloseAll()
{
      int total  = OrdersTotal();
      for (int cnt = 0 ; cnt < total ; cnt++)
      {
         OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
         if(OrderType()==OP_BUY)
            OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Violet);
         if(OrderType()==OP_SELL)   
            OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Violet);
      }
} 


int Crossed (double line1 , double line2)
   {
      static int last_direction = 0;
      static int current_direction = 0;
      
      if(line1>line2)current_direction = 1; //up
      if(line1<line2)current_direction = 2; //down

      if(current_direction != last_direction) //changed 
      {
            last_direction = current_direction;
            return (last_direction);
      }
      else
      {
            return (0);
      }
   }
   

